export declare enum ErrorCode {
    OK = 0,
    UNDEFINED = 1,
    NOT_IMPLEMENTED = 2,
    LIB_TIME_LIMIT_REACHED = 5,
    COMMAND_NOT_FOUND = 256,
    UNABLE_TO_BIND_NETWORK_PORT = 257,
    NO_NETWORK_PORT_AVAILABLE = 258,
    COMMAND_TIMED_OUT = 272,
    COMMAND_ABORTED_CONNECTION_CLOSED = 273,
    CLIENT_INVALID_ID = 512,
    CLIENT_NICKNAME_INUSE = 513,
    INVALID_ERROR_CODE = 514,
    CLIENT_PROTOCOL_LIMIT_REACHED = 515,
    CLIENT_INVALID_TYPE = 516,
    CLIENT_ALREADY_SUBSCRIBED = 517,
    CLIENT_NOT_LOGGED_IN = 518,
    CLIENT_COULD_NOT_VALIDATE_IDENTITY = 519,
    CLIENT_INVALID_PASSWORD = 520,
    CLIENT_TOO_MANY_CLONES_CONNECTED = 521,
    CLIENT_VERSION_OUTDATED = 522,
    CLIENT_IS_ONLINE = 523,
    CLIENT_IS_FLOODING = 524,
    CLIENT_HACKED = 525,
    CLIENT_CANNOT_VERIFY_NOW = 526,
    CLIENT_LOGIN_NOT_PERMITTED = 527,
    CLIENT_NOT_SUBSCRIBED = 528,
    CLIENT_UNKNOWN = 529,
    CLIENT_JOIN_RATE_LIMIT_REACHED = 530,
    CLIENT_IS_ALREADY_MEMBER_OF_GROUP = 531,
    CLIENT_IS_NOT_MEMBER_OF_GROUP = 532,
    CLIENT_TYPE_IS_NOT_ALLOWED = 533,
    CHANNEL_INVALID_ID = 768,
    CHANNEL_PROTOCOL_LIMIT_REACHED = 769,
    CHANNEL_ALREADY_IN = 770,
    CHANNEL_NAME_INUSE = 771,
    CHANNEL_NOT_EMPTY = 772,
    CHANNEL_CAN_NOT_DELETE_DEFAULT = 773,
    CHANNEL_DEFAULT_REQUIRE_PERMANENT = 774,
    CHANNEL_INVALID_FLAGS = 775,
    CHANNEL_PARENT_NOT_PERMANENT = 776,
    CHANNEL_MAXCLIENTS_REACHED = 777,
    CHANNEL_MAXFAMILY_REACHED = 778,
    CHANNEL_INVALID_ORDER = 779,
    CHANNEL_NO_FILETRANSFER_SUPPORTED = 780,
    CHANNEL_INVALID_PASSWORD = 781,
    CHANNEL_IS_PRIVATE_CHANNEL = 782,
    CHANNEL_INVALID_SECURITY_HASH = 783,
    CHANNEL_IS_DELETED = 784,
    CHANNEL_NAME_INVALID = 785,
    CHANNEL_LIMIT_REACHED = 786,
    SERVER_INVALID_ID = 1024,
    SERVER_RUNNING = 1025,
    SERVER_IS_SHUTTING_DOWN = 1026,
    SERVER_MAXCLIENTS_REACHED = 1027,
    SERVER_INVALID_PASSWORD = 1028,
    SERVER_DEPLOYMENT_ACTIVE = 1029,
    SERVER_UNABLE_TO_STOP_OWN_SERVER = 1030,
    SERVER_IS_VIRTUAL = 1031,
    SERVER_WRONG_MACHINEID = 1032,
    SERVER_IS_NOT_RUNNING = 1033,
    SERVER_IS_BOOTING = 1034,
    SERVER_STATUS_INVALID = 1035,
    SERVER_MODAL_QUIT = 1036,
    SERVER_VERSION_OUTDATED = 1037,
    SERVER_ALREADY_JOINED = 1037,
    SERVER_IS_NOT_SHUTTING_DOWN = 1038,
    SERVER_MAX_VS_REACHED = 1039,
    SERVER_UNBOUND = 1040,
    SERVER_JOIN_RATE_LIMIT_REACHED = 1041,
    SQL = 1280,
    DATABASE_EMPTY_RESULT = 1281,
    DATABASE_DUPLICATE_ENTRY = 1282,
    DATABASE_NO_MODIFICATIONS = 1283,
    DATABASE_CONSTRAINT = 1284,
    DATABASE_REINVOKE = 1285,
    PARAMETER_QUOTE = 1536,
    PARAMETER_INVALID_COUNT = 1537,
    PARAMETER_INVALID = 1538,
    PARAMETER_NOT_FOUND = 1539,
    PARAMETER_CONVERT = 1540,
    PARAMETER_INVALID_SIZE = 1541,
    PARAMETER_MISSING = 1542,
    PARAMETER_CHECKSUM = 1543,
    PARAMETER_CONSTRAINT_VIOLATION = 24592,
    VS_CRITICAL = 1792,
    CONNECTION_LOST = 1793,
    NOT_CONNECTED = 1794,
    NO_CACHED_CONNECTION_INFO = 1795,
    CURRENTLY_NOT_POSSIBLE = 1796,
    FAILED_CONNECTION_INITIALISATION = 1797,
    COULD_NOT_RESOLVE_HOSTNAME = 1798,
    INVALID_SERVER_CONNECTION_HANDLER_ID = 1799,
    COULD_NOT_INITIALISE_INPUT_CLIENT = 1800,
    CLIENTLIBRARY_NOT_INITIALISED = 1801,
    SERVERLIBRARY_NOT_INITIALISED = 1802,
    WHISPER_TOO_MANY_TARGETS = 1803,
    WHISPER_NO_TARGETS = 1804,
    FILE_INVALID_NAME = 2048,
    FILE_INVALID_PERMISSIONS = 2049,
    FILE_ALREADY_EXISTS = 2050,
    FILE_NOT_FOUND = 2051,
    FILE_IO_ERROR = 2052,
    FILE_INVALID_TRANSFER_ID = 2053,
    FILE_INVALID_PATH = 2054,
    FILE_NO_FILES_AVAILABLE = 2055,
    FILE_OVERWRITE_EXCLUDES_RESUME = 2056,
    FILE_INVALID_SIZE = 2057,
    FILE_ALREADY_IN_USE = 2058,
    FILE_COULD_NOT_OPEN_CONNECTION = 2059,
    FILE_NO_SPACE_LEFT_ON_DEVICE = 2060,
    FILE_EXCEEDS_FILE_SYSTEM_MAXIMUM_SIZE = 2061,
    FILE_TRANSFER_CONNECTION_TIMEOUT = 2062,
    FILE_CONNECTION_LOST = 2063,
    FILE_EXCEEDS_SUPPLIED_SIZE = 2064,
    FILE_TRANSFER_COMPLETE = 2065,
    FILE_TRANSFER_CANCELED = 2066,
    FILE_TRANSFER_INTERRUPTED = 2067,
    FILE_TRANSFER_SERVER_QUOTA_EXCEEDED = 2068,
    FILE_TRANSFER_CLIENT_QUOTA_EXCEEDED = 2069,
    FILE_TRANSFER_RESET = 2070,
    FILE_TRANSFER_LIMIT_REACHED = 2071,
    FILE_API_TIMEOUT = 2080,
    FILE_VIRTUAL_SERVER_NOT_REGISTERED = 2081,
    FILE_SERVER_TRANSFER_LIMIT_REACHED = 2082,
    FILE_CLIENT_TRANSFER_LIMIT_REACHED = 2083,
    SERVER_INSUFFICIENT_PERMISSIONS = 2568,
    ACCOUNTING_SLOT_LIMIT_REACHED = 2817,
    SERVER_CONNECT_BANNED = 3329,
    BAN_FLOODING = 3331,
    TOKEN_INVALID_ID = 3840,
    TOKEN_EXPIRED = 3856,
    TOKEN_USE_LIMIT_EXCEEDED = 3857,
    WEB_HANDSHAKE_INVALID = 4096,
    WEB_HANDSHAKE_UNSUPPORTED = 4097,
    WEB_HANDSHAKE_IDENTITY_UNSUPPORTED = 4098,
    WEB_HANDSHAKE_IDENTITY_PROOF_FAILED = 4099,
    WEB_HANDSHAKE_IDENTITY_OUTDATED = 4100,
    MUSIC_INVALID_ID = 4352,
    MUSIC_LIMIT_REACHED = 4353,
    MUSIC_CLIENT_LIMIT_REACHED = 4354,
    MUSIC_INVALID_PLAYER_STATE = 4355,
    MUSIC_INVALID_ACTION = 4356,
    MUSIC_NO_PLAYER = 4357,
    MUSIC_DISABLED = 4357,
    PLAYLIST_INVALID_ID = 8448,
    PLAYLIST_INVALID_SONG_ID = 8449,
    PLAYLIST_ALREADY_IN_USE = 8450,
    PLAYLIST_IS_IN_USE = 8451,
    QUERY_NOT_EXISTS = 4608,
    QUERY_ALREADY_EXISTS = 4609,
    GROUP_INVALID_ID = 4864,
    GROUP_NAME_INUSE = 4865,
    GROUP_NOT_ASSIGNED_OVER_THIS_SERVER = 4866,
    CONVERSATION_INVALID_ID = 8704,
    CONVERSATION_MORE_DATA = 8705,
    CONVERSATION_IS_PRIVATE = 8706,
    CUSTOM_ERROR = 65535,
    /** @deprecated Use SERVER_INSUFFICIENT_PERMISSIONS */
    PERMISSION_ERROR = 2568,
    /** @deprecated Use DATABASE_EMPTY_RESULT */
    EMPTY_RESULT = 1281
}
