import { Registry } from "tc-shared/events";
import { ControlBarEvents, ControlBarMode } from "tc-shared/ui/frames/control-bar/Definitions";
import { ConnectionHandler } from "tc-shared/ConnectionHandler";
import { VideoBroadcastType } from "tc-shared/connection/VideoConnection";
declare class InfoController {
    private readonly mode;
    private readonly events;
    private currentHandler;
    private globalEvents;
    private globalHandlerRegisteredEvents;
    private handlerRegisteredEvents;
    private defaultRecorderListener;
    constructor(events: Registry<ControlBarEvents>, mode: ControlBarMode);
    getCurrentHandler(): ConnectionHandler;
    getMode(): ControlBarMode;
    initialize(): void;
    destroy(): void;
    private registerDefaultRecorderEvents;
    private unregisterDefaultRecorderEvents;
    private registerGlobalHandlerEvents;
    private unregisterGlobalHandlerEvents;
    private registerCurrentHandlerEvents;
    private unregisterCurrentHandlerEvents;
    setConnectionHandler(handler: ConnectionHandler): void;
    sendConnectionState(): void;
    sendBookmarks(): Promise<void>;
    sendAwayState(): void;
    sendMicrophoneState(): void;
    sendMicrophoneList(): void;
    sendSpeakerState(): void;
    sendSpeakerList(): Promise<void>;
    sendSubscribeState(): void;
    sendQueryState(): void;
    sendHostButton(): void;
    sendVideoState(type: VideoBroadcastType): void;
    sendCameraList(): void;
}
export declare function initializePopoutControlBarController(events: Registry<ControlBarEvents>, handler: ConnectionHandler): void;
export declare function initializeControlBarController(events: Registry<ControlBarEvents>, mode: ControlBarMode): InfoController;
export {};
